require 'test/unit'
require 'LRUCache'

class TC_LRUCache < Test::Unit::TestCase
	@cache

	def setup
		assert_nothing_raised("Failed while creating an Iowa::LRUCache object") do
			@cache = Iowa::LRUCache.new(12)
			(1..14).each {|n| @cache[n] = n}
		end
	end

	def test_all
		assert_nothing_raised("Failed.") do
			s = @cache.size
			assert_equal(12,s,"The expected size (12) did not match the returned size (#{s}).")
			@cache.size=3
			s = @cache.size
			assert_equal(3,s,"The cache size does not appear to to have change as expected; want size of 3, have size of #{s}.")
			@cache['a'] = 1
			@cache['b'] = 2
			@cache['c'] = 3
			s = @cache['b']
			assert_equal(2,s,"The value retrieved from the cache (#{s}) did not match what was expected (2).")
			@cache['d'] = 4
			s = true
			s = false if @cache.include? 'a'
			assert_equal(true,s,"Key 'a' should have fallen out of the cache.  It did not.")
			s = false
			s = true if @cache.include? 'b'
			assert_equal(true,s,"Key 'b' appears to have fallen out of the cache.  It should not have.")
		end
	end
end
